/*


	 ****  ***  *   * ***** *****  ****       ***** ***** *     *****
	*     *   * *   * *       *   *           *       *   *     *
	*     *   * **  * *       *   *           *       *   *     *
	*     *   * * * * ****    *   * ***       ****    *   *     ****
	*     *   * *  ** *       *   *   *       *       *   *     *
	*     *   * *   * *       *   *   *       *       *   *     *
	 ****  ***  *   * *     *****  **** ***** *     ***** ***** *****

						=[ kirjotettu 26.01.2003 ]=
						  -----------------------
						   muokattu   30.03.2003

						    pete@markkupurho.fi


	Sepostus:

		Kirjotin tässä aika äkkiä luokan jonka avulla pystyy lataamaan muuttujia
		tekstitiedostosta. Toimii vähän samaan tapaan .ini tiedostot. Sitä voi
		käyttää erinäkösten asetusten tallentamiseen ja lataamiseen. Muuttujat
		ja niiden arvot ladataan muistiin, josta niitä voi vapauttaa käsin
		(funktiolla poista() ) tai putsaamalla koko hoidon funktiolla
		(poista_kaikki() ) tai tuhoamalla olion joka automaattisesti vapauttaa
		kaiken muistin. Mä tein tän itse yhtä peliä varten sen asetusten
		tallentamiseen ja toivottavasti tästä on hyötyä muillekkin. Yritin meinaan
		itse etsiä googlella vastaavanlaista luokkaa enkä löytäny mitään. Tätä
		saa käyttää kuka tahansa ja mihin tahansa


	Käytöstä:

		Homman pitäis toimia pelkästään liittämällä config_file.h eli lisäämällä
		#include "config_file.h"
		siihen tiedostoon missä haluat config_fileä käyttää.

		Suurin osa config_filen funktioista haluaa muuttujan nimen, joka annetaan
		stringinä.

		Config_file tuntee neljä muuttuja tyyppiä jotka ovat tyhjä, stringi,
		numero ja taulukko. Stringi on c++ string ja numero on double. Taulukko on
		vähän kinkkisempi tapaus.

		Taulukkoa voidaan käyttää kahdella tapaa joko suoraan kutsumalla esim.
		hae_num("taulukko[2]") tai sitten indexin avulla elikkä
		hae_num("taulukko", 2). Kaikkien funnktoiden pitäisi toimia taulukoille
		molemmilla tavoilla. Tosin "taulukko[2]" käskyn käyttäminen on hitaampaa
		kuin "taulukko", 2 käskyn. Mutta ero on niin pieni, että sillä ei ole
		mitään merkitystä.

		Koko funktio palauttaa suurimman taulukkoon tallennetun arvon. Ei siis
		suoraan elementtien määrää vaan suurimman arvon. Elikkä seuraavanlaisen
		taulukon koko olisi 100 :

		taulukko[1]   = tekstiä
		taulukko[2]   = tekstiä
		taulukko[100] = tekstiä

		Tyhjien	solujen yli voi hyppiä käyttämällä onko funktiota, joka kertoo
		onko kyseiseen kohtaan tallennettu mitään. Taulukoista sen verran vielä,
		että ne hyväksyvät indekseikseen vain numeroita elikkä seuraavanlainen
		taulukon solu olisi laiton

		taulukko[ kymmenen ] = 10


		Idea on käyttää config_fileä muuttujien tiedostosta lataamiseen ja sinne
		tallentamiseen, ei niiden säilyttämiseen! Se on liian hidas ja kömpelö
		siihen, että muuttujia käsiteltäisiin sen läpi. Joten kannattaa tehdä
		niin, että lataa tavarat tekstitiedostosta muuttujiin ja tyhjentää
		config_filen. Ja ohjelman loputtua / saivaiksen yhteydessä tallennetaan
		muuttujat takasin tiedostoon.


	Yhteystiedot:

		Tän pitäis olla muistivuoto vapaa, mutta bugeja on saattanu eksyä joukoon.
		Niistä voi pistää mulle mailia osotteeseen pete@markkupurho.fi .  Mä voin
		yrittää korjata niitä parhaani kykyni mukaan. Samoin muutakin palautetta
		saa pistää.

		Petri Purho ( c ) 2003




*/
#ifndef INC_CONFIG_FILE_H
#define INC_CONFIG_FILE_H

#pragma warning(disable:4786) // Poistaa ilkeet warningit mitä stl antaa jos käyttää stringiä



#include <string>
#include <map>


// using namespace std;



#define CF_TYHJA  -1
#define CF_STRING 1
#define CF_NUMBER 2
#define CF_TABLE  3



class config_file {


public:


	// Konstruktorit ja dekonstruktorit
	config_file() { }
	config_file( std::string tiedoston_nimi ) { lataa_tiedosto( tiedoston_nimi ); }
	~config_file() { poista_kaikki(); }

	// "rajapinnat", eli toiminta periaatteet

	// jos haettavia muuttujia ei ole olemassa palautetaan tyhjät arvot, eli stringinä "" ja doublena 0
	std::string hae_str( std::string muuttujan_nimi );	// Palauttaa stringinä kyseessä olevan muuttujan arvon,
														// jos muuttuja on numero ja sitä pyydetään stringinä niin
														// palautetaan stringinä se numero

	double hae_num( std::string muuttujan_nimi );		// Palauttaa doublena kyseessä olevan muuttujan arvon,
														// jos taas kyseinen muuttuja on teksti ja sitä pyydetään
														// numerona palautetaan arvo 0

	std::string hae_str( std::string muuttujan_nimi, int index );	// Tekee samat kun edelliset, mutta taulukoille
	double		hae_num( std::string muuttujan_nimi, int index );	// Sama homma


	bool onko_str( std::string muuttujan_nimi );		// Kertoo onko kyseinen muuttuja string tyyppiä
	bool onko_num( std::string muuttujan_nimi );		// Kertoo onko kyseinen muuttuja numero
	bool onko_tab( std::string muuttujan_nimi );		// Kertoo onko kyseinen muuttuja taulukko
	bool onko    ( std::string muuttujan_nimi );		// Kertoo onko meillä muistissa kyseistä muuttujaa

	bool onko_str( std::string muuttujan_nimi, int index ); // Taulukko vastine onko_str:lle
	bool onko_num( std::string muuttujan_nimi, int index ); // Taulukko vastine onko_num:lle
	bool onko( std::string muuttujan_nimi, int index );		// Taulukko vastine onko:lle


	int	 tyyppi  ( std::string muuttujan_nimi );			// Kertoo muuttujan tyypin
	int	 tyyppi  ( std::string muuttujan_nimi, int index );	// Kertoo muuttujan tyypin taulukon solusta

	int  koko( std::string muuttujan_nimi );				// Palauttaa kyseisen muuttujan koon eli perus muuttujissa palauttaa nollan ja taulukossa se palauttaa taulukon koon

	// tallenna funktioita voi myös käyttää arvojen muuttamiseen
	void tallenna( std::string muuttujan_nimi, std::string arvo );				// tallentaa muuttujan ja sen arvon muistiin
	void tallenna( std::string muuttujan_nimi, double arvo );					// tallentaa muuttujan ja sen arvon muistiin
	void tallenna( std::string muuttujan_nimi, int index, std::string arvo );	// tallentaa muuttujan ja sen taulukon arvon muistiin
	void tallenna( std::string muuttujan_nimi, int index, double arvo );		// tallentaa muuttujan ja sen taulukon arvon muistiin


	void poista( std::string muuttujan_nimi );				// poistaa kyseisen muuttujan muistista
	void poista( std::string muuttujan_nimi, int index );	// poistaa yhden solun taulusta
	void poista_kaikki();									// poistaa kaikki muuttujat ja niiden arvot

	void lataa_tiedosto( std::string		tiedoston_nimi );		// lataa muuttujat tiedostosta
	void tallenna_tiedostoon( std::string	tiedoston_nimi );	// tallentaa kaikki muistissa olevat muuttujat ASCII tiedostoon,
																// tää muuten sitten tuhoaa sen tiedoston jonka päälle kirjotetaan

	class cf_muuttuja;
	class cf_muuttuja_str;
	class cf_muuttuja_num;
	class cf_muuttuja_tab;

private: // parts of howard stern

	// muuttuja luokka, tätä käytetään muuttujien arvojen tallentamiseen
	// Valitettavasti tätä sisäistä toimintaa ei oo kauheesti kommentoitu, koska ei yksinkertasesti ollu aikaa.
	// mun pitää lähteä tossa reilu kolmen tunnin päästä takasin inttiin, joten tää kommentointi jäi aika vähäseks

	// pikasesti idea on siinä, että tallennetaan mappiin pointteri cf_muuttujaan nämä pointterit sitten tuhotaan
	// deletellä sopivassa välissä...

	bool		tau_onko_table( std::string muuttujan_nimi ) { if ( muuttujan_nimi.find_last_of( "[" ) != muuttujan_nimi.npos && muuttujan_nimi.find_last_of( "]" ) != muuttujan_nimi.npos ) return true; else return false; }
	std::string	tau_lue_nimi( std::string muuttujan_nimi ) {

		size_t kohdistin = muuttujan_nimi.find_last_of( "[" );

		// Tarkistetaan onko taulu
		if ( kohdistin != muuttujan_nimi.npos && muuttujan_nimi.find_last_of( "]" ) != muuttujan_nimi.npos ) {

			muuttujan_nimi  = muuttujan_nimi.substr( 0, kohdistin );

			// Poistetaan whitespacet
			kohdistin = muuttujan_nimi.find_first_not_of(" \t");
			muuttujan_nimi.erase( 0,  kohdistin );

			kohdistin = muuttujan_nimi.find_last_not_of(" \t");
			muuttujan_nimi.erase( kohdistin+1 );
		}

		return muuttujan_nimi;


	}

	int tau_lue_index( std::string muuttujan_nimi ) {
		int index = 0;

		size_t kohdistin =  muuttujan_nimi.find_last_of( "[" );

		// Tarkistetaan onko taulu
		if ( kohdistin != muuttujan_nimi.npos && muuttujan_nimi.find_last_of( "]" ) != muuttujan_nimi.npos ) {

			std::string muuttujan_index;

			// Leikataan eka osa
			muuttujan_index = muuttujan_nimi.substr( kohdistin + 1);



			// poistetaan whitespacet alusta
			kohdistin = muuttujan_index.find_first_not_of(" \t");
			muuttujan_index.erase( 0,  kohdistin );

			// etsitään kohta jossa numerot muuttuu joskin muuks
			kohdistin = muuttujan_index.find_first_not_of("0123456789.+-");

			muuttujan_index = muuttujan_index.erase( kohdistin );

			// cout << "index on " << muuttujan_index << endl;

			index = atoi( muuttujan_index.c_str() );


		}
		return index;
	}


	std::map < std::string, cf_muuttuja* >				sisalto;		// sisältää kaikki muuttujat ja niiden arvot
	std::map < std::string, cf_muuttuja* >::iterator	sisalto_selain; // tällä voidaan surffailla sisallossä


};


#endif
