#include "aika.h"

minsec aika::haeAika() {
    minsec pal;

    clock_t ero = clock() - aika;
    int min, sec, mm;
    // Nykyinen aikaero sekunteina (esim. 64.336514)
    double murto = (double)ero / CLK_TCK;
    // Kokonaisosa talteen (esim. 64)
    sec = (int)(murto);
    // murto-muuttujaan desimaalit (- sekunnit), esim .336514
    // ja sitten haluttuun tarkkuuteen pyöristys, tässä 2
    // desimaalin tarkkuudella eli * 100 ja pyöristys.
    // Tässä nyt esim. .336514 => 34
    mm = (int)(((murto - (double)sec) * 100) + 0.5);
    // Minuutit taas ovat... sekunnit jaettuna 60:llä,
    // esim. tässä 64 / 60 = 1.06666... => 1
    min = (int)((double)sec / 60);
    // Ja lopuksi minuutit pois sekunneista, esim. täss nyt
    // sitten 64 - 1 * 60 = 4.
    // Lopputuloste: 1:4.34
    sec -= (min * 60);

    pal.min = min;
    pal.sec = sec;
    pal.mm = mm;

    return pal;
}

void aika::alustaAika() {
    aika = clock();
}
