#include "alkudemo.h"

void Alkudemo::lataa() {
    pappi_x = 0;
    pappi_y = 0;

    pappio = IMG_Load("media/images/peli_pappi.png");
    pappiv = IMG_Load("media/images/peli_pappiv.png");

    henkilo = IMG_Load("media/images/peli_hahmo.png");

    tausta = IMG_Load("media/images/pelidemo_tausta.png");

    tekstit[0] = "Apuri:  Hei, minulla on sinulle tehtävä.";
    tekstit[1] = "Minä: Mikä tehtävä?";

    tekstit[2] = "Apuri kääntyi minua vastaan.";

    tekstit[3] = "Apuri: Sinun täytyy pelastaa yhteiskunta.";
    tekstit[4] = "Minä: No, mikäpäs siinä.";

    tekstit[5] = "Apuri: Mene saharan aavikolle, sinne on Magnus taikonut taian.";
    tekstit[6] = "Apuri: Se taika laittoi hiekan ilmaan, sellaisiksi tasoiksi.";
    tekstit[7] = "Apuri: Mene niitä pitkin mahdollisilman ylös ja tapa siellä Magnus";
    tekstit[8] = "Minä: Mitäs se on tehnyt?";

    tekstit[9] = "Apuri: Muutama vuosi takaperin muuan Magnus taikoi maapallolle taian.";
    tekstit[10] = "Apuri: Se muutti kaiken esineellisen hiekaksi ja nosti sitten ne ilmaan.";
    tekstit[11] = "Apuri: Mutta se siitä, sinun täytyy kiirehtiä, aikaa on rajoitetusti";
    tekstit[12] = "Apuri: Magnus nimittäin muutti hiekaksi kaikki meidän makkarat.";

    tekstit[13] = "Minä: Minä menen...";

    teksti_fontti = LoadFont("media/fonts/juoni.ttf", 35);

    Uint32 rmask, gmask, bmask, amask;

    /* SDL interprets each pixel as a 32-bit number, so our masks must depend
       on the endianness (byte order) of the machine */
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
    rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;
#else
    rmask = 0x000000ff;
    gmask = 0x0000ff00;
    bmask = 0x00ff0000;
    amask = 0xff000000;
#endif

    buf = SDL_CreateRGBSurface(SDL_HWSURFACE, 1024, 768, 32,
                                   rmask, gmask, bmask, amask);

    PiirraKuva(tausta, buf, 0, 0);
    PiirraKuva(IMG_Load("media/images/kuva10.png"), buf, 10, 350);
    PiirraKuva(IMG_Load("media/images/kuva7.png"), buf, 540, 245);

    PiirraKuva(henkilo, buf, 200, 600);
}

int Alkudemo::aloita(SDL_Surface *naytto) {
    int i = 0;

    pois = false;

    SDL_Color taustaVari = {0, 0, 0, 0};
    SDL_Color tekstiVari = {0, 0, 0, 255};

    while (!pois and i < 14) {
        while (SDL_PollEvent(&tapahtuma)) {
            switch( tapahtuma.type ) {
                case SDL_QUIT:
                    pois = true;
                    break;
                case SDL_KEYDOWN:
                    switch (tapahtuma.key.keysym.sym) {
                        case SDLK_ESCAPE:
                            pois = true;
                            break;
                        case SDLK_SPACE:
                            i++;
                            break;
                    }
                    break;
            }
        }

        //SDL_FillRect(naytto, 0, SDL_MapRGB(naytto->format, 0, 0, 0));

        PiirraKuva(buf, naytto, 0, 0);

        if (i > 1)
            PiirraKuva(pappiv, naytto, 700, 133);
        else
            PiirraKuva(pappio, naytto, 700, 133);

        sprintf(teksti_buf, tekstit[i].c_str());
        blitText(teksti_fontti, &teksti, tekstiVari,taustaVari, teksti_buf, blended);
        PiirraKuva(teksti, naytto, 0, 0);

        SDL_Flip(naytto);
    }
}

void Alkudemo::PiirraKuva(SDL_Surface *kuva, SDL_Surface *naytto, int x, int y)
{
  SDL_Rect alue; // mille alueellä näyttöä kuva piirretään
  alue.x = x; // koordinaatit
  alue.y = y;
  SDL_BlitSurface(kuva, NULL, naytto, &alue); // piirto
}

TTF_Font* Alkudemo::LoadFont(char *filename, int ptsize) {  //Fontin latausfunktio [tiedostonimi, fonttikoko]
    TTF_Font* temppi; //Väliaikainen muuttuja
    temppi = TTF_OpenFont(filename, ptsize);  //Ladataan fontti
    if (temppi == NULL) {
        cout << "Fontti ei voitu ladata:" << TTF_GetError() << endl;
        //Fontin lataaminen ei onnistunut. std::cout on kommentoitu pois koska tässä projektissa en sitä käytä, mutta olkoon esimerkkinä.
        //Lisää tähän haluamasi virheilmoitus!
    }
    return temppi; //Palautetaan fontti
}

void Alkudemo::blitText(TTF_Font *fontti, SDL_Surface **destSurf, SDL_Color fgColor, SDL_Color bgColor, char teksti[], textquality quality) {

    //tutkitaan piirtotapa ja piirretään sen mukaisesti
    if (quality == solid) {
        *destSurf = TTF_RenderText_Solid(fontti, teksti, fgColor);
    } else if (quality == shaded) {
        *destSurf = TTF_RenderText_Shaded(fontti, teksti, fgColor, bgColor);
    } else if (quality == blended) {
        *destSurf = TTF_RenderText_Blended(fontti, teksti, fgColor);
    }
}

