#ifndef _KARTTA_H
#define _KARTTA_H

#include <SDL.h>

#include <vector>
#include <string>


#include "../common/common.h"
#include "aika.h"

using namespace std;

/*
  x,y      y,x2
   \       /
    x-----x
    |     |
    |     |
    x-----x
   /       \
  x,y2    y2, x2
*/

/*
32x32
_____
|_|_|   =   0
  |_|

_____
|_|_|   =   1
|___|

_____
|_|_|   =   2
|_|

  ___
  | |   =   3
  |_|

____
|   |   =   4
|___|

___
| |     =   5
|_|

  ___
 _|_|   =   6
|_|_|

_____
|___|   =   7
|_|_|

___
|_|_    =   8
|_|_|

        =   9 (ei mitään)


*/

/*
act
0. Ei mitään
1. Aloitus
2. Lopetus

*/

struct pala {
    int x;
    int y;
    int k;
    bool solid;

    int act;
};

class Kartta {
	private:
        //Muuttujat
        aika aika_kent;

        vector<pala> kentta; //Tällä säilytetään numeroita
        vector<pala>::iterator kentta_iter;
        int koko; //Yhden palan koko

        int lev, kor;

        int vier_x;
        int vier_y;

        SDL_Surface *palat[9];
        SDL_Surface *tausta;
        SDL_Surface *kartta;

        //Functiot
        SDL_Surface *piirraPalanen(SDL_Surface *palanen, SDL_Surface *naytto, int x, int y);
	public:
        void luoNelio(int alkux, int alkuy, int leveys, int korkeus);
        void lataaKuvat();
        bool tarkistaTormays(int x, int y);

        void piirraKentta();
        int haeRuudunkoko();

        void lataaKartta(string file);
        void tallennaKartta(string filename);

        void asetaVier(int x, int y);

        int haeVier_Y();
        int haeVier_X();

        void rajoita_Vier();
        void vier(int x, int y);

        void piirraKartta(SDL_Surface *naytto);

        int haeAlkuP_X();
        int haeAlkuP_Y();

        int haeLeveys();
        int haeKorkeus();

        void poistaKaikkiPalikkat();

        minsec haeAika();
};

#endif
