#include "loppudemo.h"

void loppudemo::lataa() {
    ukko_s[1] = IMG_Load("media/images/ukko_saippuak_1.png");
    ukko_s[2] = IMG_Load("media/images/ukko_saippuak_2.png");
    ukko_s[3] = IMG_Load("media/images/ukko_saippuak_3.png");
    ukko_s[4] = IMG_Load("media/images/ukko_saippuak_1.png");
    ukko_s[5] = IMG_Load("media/images/ukko_saippuak_2.png");
    ukko_s[6] = IMG_Load("media/images/ukko_saippuak_3.png");
    ukko_s[7] = IMG_Load("media/images/ukko_saippuak_1.png");

    henkilo = IMG_Load("media/images/hahmo_edesta.png");
    henkilo2 = IMG_Load("media/images/henkilo2.png");

    tausta = IMG_Load("media/images/peliloppudemo_tausta.png");

    tekstit[0] = "Myöhemmin illalla, kun Magnus oli tapettu:";
    tekstit[1] = "Pst, mikä sinun nimi on?";
    tekstit[2] = "Veikko";
    tekstit[3] = "Onnitelkaamme Veikkoa!";
    tekstit[4] = "Hän pelasti yhteiskunnan ja tappoi Magnuksen.";

    teksti_fontti = LoadFont("media/fonts/juoni.ttf", 35);
    aika_fontti = LoadFont("media/fonts/normaali.ttf", 22);

    ukko_s[0] = IMG_Load("media/images/ukko_saippuak_0.png");

    Uint32 rmask, gmask, bmask, amask;

    /* SDL interprets each pixel as a 32-bit number, so our masks must depend
       on the endianness (byte order) of the machine */
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
    rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;
#else
    rmask = 0x000000ff;
    gmask = 0x0000ff00;
    bmask = 0x00ff0000;
    amask = 0xff000000;
#endif

    buf = SDL_CreateRGBSurface(SDL_HWSURFACE, 1024, 768, 32,
                                   rmask, gmask, bmask, amask);

    PiirraKuva(tausta, buf, 0, 0);

    PiirraKuva(henkilo, buf, 600, 165);
    PiirraKuva(henkilo2, buf, 700, 0);
}

int loppudemo::aloita(SDL_Surface *naytto, vector<minsec> ajat) {

    int i = 0;

    pois = false;

    SDL_Color taustaVari = {0, 0, 0, 0};
    SDL_Color tekstiVari = {255, 255, 255, 255};

    while (!pois and i < 6) {
        while (SDL_PollEvent(&tapahtuma)) {
            switch( tapahtuma.type ) {
                case SDL_QUIT:
                    pois = true;
                    break;
                case SDL_KEYDOWN:
                    switch (tapahtuma.key.keysym.sym) {
                        case SDLK_ESCAPE:
                            pois = true;
                            break;
                        case SDLK_SPACE:
                            i++;
                            break;
                    }
                    break;
            }
        }

        //SDL_FillRect(naytto, 0, SDL_MapRGB(naytto->format, 0, 0, 0));

        PiirraKuva(buf, naytto, 0, 0);

        PiirraKuva(ukko_s[i], naytto, 400, 150);

        sprintf(teksti_buf, tekstit[i].c_str());
        blitText(teksti_fontti, &teksti, tekstiVari,taustaVari, teksti_buf, blended);
        PiirraKuva(teksti, naytto, 0, 0);

        SDL_Flip(naytto);
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


    SDL_FillRect(buf, 0, SDL_MapRGB(buf->format, 0, 0, 0));

    vector<minsec>::iterator iter;
    iter = ajat.begin();

    i = 0;

    while (iter != ajat.end()) {
        minsec v = *iter;

        string t;
        ostringstream virta;
        virta << v.min << ":" << v.sec << "." << v.mm << endl;
        sprintf(teksti_buf, (virta.str()).c_str());

        blitText(aika_fontti, &teksti, tekstiVari,taustaVari, teksti_buf, blended);

        PiirraKuva(teksti, buf, 500, 40*i);

        iter++;
        i++;
    }


    blitText(teksti_fontti, &teksti, tekstiVari,taustaVari, "Onneksi olkoon, pelasit pelin läpi!", blended);
    PiirraKuva(teksti, buf, 300, 382);

    blitText(teksti_fontti, &teksti, tekstiVari,taustaVari, "Nimi:", blended);
    PiirraKuva(teksti, buf, 300, 450);

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    iter = ajat.begin();

    i = 0;

    hiscore tulokset;

    vector<score> tul;
    tul = tulokset.haeTulokset();

    int pisteet;

    iter = ajat.begin();
    while (iter != ajat.end()) {
        pisteet += (*iter).sec;
        pisteet += (*iter).min / 60;
        pisteet += (*iter).mm * 100;

        iter++;
    }

    pois = false;

    string nimi;

    SDL_EnableUNICODE( SDL_ENABLE );

    while (!pois) {
        while (SDL_PollEvent(&tapahtuma)) {
            switch( tapahtuma.type ) {
                case SDL_QUIT:
                    pois = true;
                    break;
                case SDL_KEYDOWN:
                    string temp;
                    if ( nimi.length() <= 16 ) {
                        if ((tapahtuma.key.keysym.unicode >= (Uint16)'0') && (tapahtuma.key.keysym.unicode <= (Uint16)'9')) {
                            nimi += (char)tapahtuma.key.keysym.unicode;
                        } else if ((tapahtuma.key.keysym.unicode >= (Uint16)'A') && (tapahtuma.key.keysym.unicode <= (Uint16)'Z')) {
                            nimi += (char)tapahtuma.key.keysym.unicode;
                        } else if ((tapahtuma.key.keysym.unicode >= (Uint16)'a') && (tapahtuma.key.keysym.unicode <= (Uint16)'z')) {
                            nimi += (char)tapahtuma.key.keysym.unicode;
                        }
                    }

                    if ((tapahtuma.key.keysym.sym == SDLK_BACKSPACE) && (nimi.length() != 0)) {
                        nimi.erase(nimi.length() - 1);
                    }

                    switch (tapahtuma.key.keysym.sym) {
                        case SDLK_ESCAPE:
                            pois = true;
                            break;
                        case SDLK_RETURN:
                            //Tallennetaan nimi ja pistemaara
                            score uusi;
                            uusi.pisteet = pisteet;
                            uusi.nimi = nimi;

                            tul.push_back(uusi);

                            sort(tul.begin(), tul.end());

                            tulokset.tallennaTulokset(tul);

                            pois = true;
                            break;
                    }
                    break;
            }
        }
        PiirraKuva(buf, naytto, 0, 0);

        ostringstream virta;
        virta << nimi << endl;
        sprintf(teksti_buf, (virta.str()).c_str());
        blitText(aika_fontti, &teksti, tekstiVari,taustaVari, teksti_buf, blended);

        PiirraKuva(teksti,naytto, 400, 430);

        SDL_Flip(naytto);
    }
    return 0;
}

TTF_Font *loppudemo::LoadFont(char *filename, int ptsize) {
    TTF_Font* temppi; //Väliaikainen muuttuja
    temppi = TTF_OpenFont(filename, ptsize);  //Ladataan fontti
    if (temppi == NULL) {
        cout << "Fontti ei voitu ladata:" << TTF_GetError() << endl;
    }
    return temppi; //Palautetaan fontti
}

void loppudemo::blitText(TTF_Font *fontti, SDL_Surface **destSurf, SDL_Color fgColor, SDL_Color bgColor, char teksti[], textquality quality) {
    //tutkitaan piirtotapa ja piirretään sen mukaisesti
    if (quality == solid) {
        *destSurf = TTF_RenderText_Solid(fontti, teksti, fgColor);
    } else if (quality == shaded) {
        *destSurf = TTF_RenderText_Shaded(fontti, teksti, fgColor, bgColor);
    } else if (quality == blended) {
        *destSurf = TTF_RenderText_Blended(fontti, teksti, fgColor);
    }
}

void loppudemo::PiirraKuva(SDL_Surface *kuva, SDL_Surface *naytto, int x, int y) {
    SDL_Rect alue; // mille alueellä näyttöä kuva piirretään
    alue.x = x; // koordinaatit
    alue.y = y;
    SDL_BlitSurface(kuva, NULL, naytto, &alue); // piirto
}

inline bool operator < (const score &Ensimmainen, const score &Toinen)
{
  if (Ensimmainen.pisteet < Toinen.pisteet)
    return true;
  return false;
}
