#include <SDL_image.h>
#include <SDL_ttf.h>
#include <iostream>
#include <sstream>
#include "peli.h"
#include "alkudemo.h"
#include "../fmod/fmod.h"

using namespace std;

void Peli::lataa(FMOD_SYSTEM *system) {
    kentta.lataaKuvat();
    kentta.lataaKartta("levels/level6.map");
    //kentta.lataaKartta("Olematon.map");
    kentta.piirraKentta();
    hahmo.lataa(system);

    kenttia = 6;

    aika_fontti = LoadFont("media/fonts/normaali.ttf", 22);

    FMOD_System_CreateSound(system, "media/sounds/aani5.mp3", FMOD_DEFAULT, 0, &kentta_lapi);
}

void Peli::peliin(SDL_Surface *naytto, FMOD_SYSTEM *system, bool aanet) {

    alkudemo.lataa();
    alkudemo.aloita(naytto);

    pois = false;

    bool lapi;

    SDL_Color taustaVari = {0, 0, 0, 0};
    SDL_Color tekstiVari = {0, 0, 0, 255};

    while (!pois) {
        // poistutaanko
        SDL_PollEvent(&tapahtuma);
        //Jos Windows pakottaa poistumisen
        if ( tapahtuma.type == SDL_QUIT )
            pois = true;

        //Jos käyttäjä haluaa poistumisen
        if ( tapahtuma.type == SDL_KEYDOWN )
                if ( tapahtuma.key.keysym.sym == SDLK_ESCAPE )
                    pois = true;

        //kentta.vier(1, 0);
        kentta.vier(hahmo.haeX() -  512, hahmo.haeY() - 382);
        kentta.rajoita_Vier();

        hahmo.ajattele(kentta, system, aanet);

        if ((hahmo.haeX()/32) == 83 and (hahmo.haeY()/32) == 13) {
            kenttia--;

            ajat.push_back(kentta.haeAika());

            if (kenttia <= 0) {
                lapi = true;
                break;
            } else {
                string t;
                ostringstream virta;
                virta << "levels/level" << kenttia << ".map";

                kentta.poistaKaikkiPalikkat();
                kentta.lataaKartta(virta.str());
                kentta.piirraKentta();
                hahmo.asetaPaikka(3*32, 28*32);
            }

            if (aanet) {
                FMOD_System_PlaySound(system, FMOD_CHANNEL_FREE, kentta_lapi, false, &chan); //Ja soitetaan se
                FMOD_Channel_SetVolume(chan, 1);
            }
        }

        if (hahmo.haeY() > (kentta.haeKorkeus()*32)) {
            hahmo.asetaPaikka(3*32, 28*32);
        }


        //SDL_FillRect(naytto, 0, SDL_MapRGB(naytto->format, 23, 146, 235));
        kentta.piirraKartta(naytto);
        hahmo.piirra(naytto, kentta);

        minsec v = kentta.haeAika();

        string t;
        ostringstream virta;
        virta << v.min << ":" << v.sec << "." << v.mm << endl;
        sprintf(buf, (virta.str()).c_str());

        blitText(aika_fontti, &aika_pinta, tekstiVari,taustaVari, buf, blended);

        PiirraKuva(aika_pinta, naytto, 850, 10);
        SDL_Flip(naytto);
    }

    if (lapi == true) {
        loppu.lataa();
        loppu.aloita(naytto, ajat);
    }
}

void Peli::PiirraKuva(SDL_Surface *kuva, SDL_Surface *naytto, int x, int y)
{
  SDL_Rect alue; // mille alueellä näyttöä kuva piirretään
  alue.x = x; // koordinaatit
  alue.y = y;
  SDL_BlitSurface(kuva, NULL, naytto, &alue); // piirto
}

TTF_Font* Peli::LoadFont(char *filename, int ptsize) {  //Fontin latausfunktio [tiedostonimi, fonttikoko]
    TTF_Font* temppi; //Väliaikainen muuttuja
    temppi = TTF_OpenFont(filename, ptsize);  //Ladataan fontti
    if (temppi == NULL) {
        cout << "Fontti ei voitu ladata:" << TTF_GetError() << endl;
        //Fontin lataaminen ei onnistunut. std::cout on kommentoitu pois koska tässä projektissa en sitä käytä, mutta olkoon esimerkkinä.
        //Lisää tähän haluamasi virheilmoitus!
    }
    return temppi; //Palautetaan fontti
}

void Peli::blitText(TTF_Font *fontti, SDL_Surface **destSurf, SDL_Color fgColor, SDL_Color bgColor, char teksti[], textquality quality) {

    //tutkitaan piirtotapa ja piirretään sen mukaisesti
    if (quality == solid) {
        *destSurf = TTF_RenderText_Solid(fontti, teksti, fgColor);
    } else if (quality == shaded) {
        *destSurf = TTF_RenderText_Shaded(fontti, teksti, fgColor, bgColor);
    } else if (quality == blended) {
        *destSurf = TTF_RenderText_Blended(fontti, teksti, fgColor);
    }
}
