#ifndef _PELI_H
#define _PELI_H

#include <SDL.h>
#include <vector>

#include "ukko.h"
#include "kartta.h"
#include "alkudemo.h"
#include "loppudemo.h"
#include "../fmod/fmod.h"

using namespace std;

class Peli {
	private:
        enum textquality {solid, shaded, blended};

        vector<minsec> ajat;

        int kenttia;
        Ukko hahmo;
        Kartta kentta;

        SDL_Event tapahtuma;

        bool pelissa; //Jos ollaan valikossa niin tämä on false
        bool pois;

        void PiirraKuva(SDL_Surface *kuva, SDL_Surface *naytto, int x, int y);

        char buf[100];
        TTF_Font *aika_fontti;
        SDL_Surface *aika_pinta;

        TTF_Font *LoadFont(char *filename, int ptsize);
        void blitText(TTF_Font *fontti, SDL_Surface **destSurf, SDL_Color fgColor, SDL_Color bgColor, char teksti[], textquality quality);


        Alkudemo alkudemo;
        loppudemo loppu;

        FMOD_SOUND *kentta_lapi;
        FMOD_CHANNEL *chan;
	public:
        void lataa(FMOD_SYSTEM *system);
        void peliin(SDL_Surface *naytto, FMOD_SYSTEM *system, bool aanet);
};

#endif
