#ifndef _ASETUSVALIKKO_H
#define _ASETUSVALIKKO_H

#include <iostream>
#include <vector>
#include <SDL.h>

using namespace std;

struct asetus_valikko_kohta {
    int x;
    int y;
    int l;
    int k;
    SDL_Surface *nappi;
    SDL_Surface *nappi_alhaalla;

    bool tosi;
    int hienosx;
    int hienosy;
};

class asetus_valikko {
    private:
        vector<asetus_valikko_kohta> valinta; //Kaikki valinta kohdat
        vector<asetus_valikko_kohta>::iterator valinta_iter;

        int valittu; //Nykyinen valinta

        SDL_Surface *palautus; //Palautetaan

        SDL_Surface *tosi; //Tosi-kohdan kuva
        SDL_Surface *epatosi; //Epätosi-kohdan kuva

        SDL_Surface *tosiv; //Tosi-kohdan kuva v = valittu
        SDL_Surface *epatosiv; //Epätosi-kohdan kuva

        void piirraValinta(SDL_Surface *kuva, SDL_Surface *naytto, int x, int y);
    public:
        virtual void piirraPinta(SDL_Surface *naytto);
        void asetaTosiJaEpatosi(SDL_Surface *t, SDL_Surface *et, SDL_Surface *tv, SDL_Surface *etv);

        virtual void lisaaValinta(SDL_Surface *nappi, SDL_Surface *nappi_alhaalla, int x, int y, int l, int k, bool tosiko, int hsx, int hsy);
        virtual void poistaValinta(int mones);

        int haeValinta();
        void asetaValinta(int v);
        void asetaLisaaValinta(int plus);

        void vaihdaTosi(int mones);

        bool haeArvo(int mones);

        asetus_valikko();
};

#endif
