#ifndef _VALIKKO_H
#define _VALIKKO_H

#include <SDL.h>
#include <SDL_image.h>
#include <vector>

#include "../common/common.h"

using namespace std;

struct valikko_kohta {
    int x;
    int y;
    int l;
    int k;
    SDL_Surface *nappi;
    SDL_Surface *nappi_alhaalla;
};

class valikko {
    private:
        vector<valikko_kohta> valinta; //Kaikki valinta kohdat
        vector<valikko_kohta>::iterator valinta_iter;

        int valittu; //Nykyinen valinta

        SDL_Surface *palautus; //Palautetaan

        void piirraValinta(SDL_Surface *kuva, SDL_Surface *naytto, int x, int y);
    public:
        virtual void piirraPinta(SDL_Surface *naytto);

        virtual void lisaaValinta(SDL_Surface *nappi, SDL_Surface *nappi_alhaalla, int x, int y, int l, int k);
        virtual void poistaValinta(int mones);

        int haeValinta();
        void asetaValinta(int v);
        void asetaLisaaValinta(int plus);

        valikko();
};

#endif
